﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using SER_Bootstrap_Test.Models;
using Syncfusion.JavaScript;
using System.Collections;
using Syncfusion.JavaScript.DataSources;

namespace SER_Bootstrap_Test.Controllers
{
    public class TClientesController : Controller
    {
        private SER_Gestion_Entities db = new SER_Gestion_Entities();

        // GET: TClientes
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = db.TClientes.ToList();
            DataResult result = new DataResult();
            DataOperations obj = new DataOperations();
            if (dm.Skip != 0)
            {
                DataSource = obj.PerformSkip(DataSource, dm.Skip); // Skip function
            }
            if (dm.Take != 0)
            {
                DataSource = obj.PerformTake(DataSource, dm.Take); // Take function
            }
            result.result = DataSource;
            result.count = db.TClientes.Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        public ActionResult Index()
        {
            //return View(db.TClientes.ToList());

            //var DataSource = db.TClientes.ToList();
            //ViewBag.datasource = DataSource;
            //return View();

            List<TClientes> Clientes = new List<TClientes>();
            Clientes.Add(new TClientes() { Id = "1", Codigo = 430001, NFiscal = "John Beckett", EMail = "john@syncfusion.com" });
            Clientes.Add(new TClientes() { Id = "2", Codigo = 430002, NFiscal = "Ben Beckett", EMail = "ben@syncfusion.com" });
            Clientes.Add(new TClientes() { Id = "3", Codigo = 430003, NFiscal = "Andrew Beckett", EMail = "andrew@syncfusion.com" });
            ViewBag.datasource = Clientes;
            return View();


            //var DataSource = db.TClientes.ToList();
            //ViewData["datasource"] = DataSource;
            //return PartialView("_partial", ViewData);

            //var data = db.TClientes.ToList();
            //ViewBag.datasource = data;
            //return View(); //Json(data, JsonRequestBehavior.AllowGet);
        }

        // GET: TClientes/Details/5
        public ActionResult Details(string id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TClientes tClientes = db.TClientes.Find(id);
            if (tClientes == null)
            {
                return HttpNotFound();
            }
            return View(tClientes);
        }

        // GET: TClientes/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: TClientes/Create
        // Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        // más información vea http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,Codigo,NFiscal,CIF,Nombre,Direccion,CP,Localidad,Provincia,Telefono,Movil,Fax,PContacto,Web,EMail,Observaciones")] TClientes tClientes)
        {
            if (ModelState.IsValid)
            {
                db.TClientes.Add(tClientes);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            return View(tClientes);
        }

        // GET: TClientes/Edit/5
        public ActionResult Edit(string id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TClientes tClientes = db.TClientes.Find(id);
            if (tClientes == null)
            {
                return HttpNotFound();
            }
            return View(tClientes);
        }

        // POST: TClientes/Edit/5
        // Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        // más información vea http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,Codigo,NFiscal,CIF,Nombre,Direccion,CP,Localidad,Provincia,Telefono,Movil,Fax,PContacto,Web,EMail,Observaciones")] TClientes tClientes)
        {
            if (ModelState.IsValid)
            {
                db.Entry(tClientes).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(tClientes);
        }

        // GET: TClientes/Delete/5
        public ActionResult Delete(string id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TClientes tClientes = db.TClientes.Find(id);
            if (tClientes == null)
            {
                return HttpNotFound();
            }
            return View(tClientes);
        }

        // POST: TClientes/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(string id)
        {
            TClientes tClientes = db.TClientes.Find(id);
            db.TClientes.Remove(tClientes);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
